Attribute VB_Name = "UploadScript"

'You need reference to Microsoft WinHTTP Services 5.0 or 5.1 to use this example

'Credit to Joseph Z. Xu (jzxu@napercom.com)
'Modified by Mohd Idzuan Alias (iklan2k@yahoo.com) August 18, 2004

Dim WinHttpReq As WinHttp.WinHttpRequest
Const HTTPREQUEST_SETCREDENTIALS_FOR_SERVER = 0
Const HTTPREQUEST_SETCREDENTIALS_FOR_PROXY = 1
Const BOUNDARY = "Xu02=$"
Const HEADER = "--Xu02=$"
Const FOOTER = "--Xu02=$--"

Function UploadFiles(strFileName As Variant, strURL As String, DirPath As String, Optional postVar As String, _
                     Optional strUserName As String, Optional strPassword As String) As String

    Dim fname As String
    Dim strFile As String
    Dim strBody As String
    Dim aPostBody() As Byte
    Dim nFile As Integer
        
    Set WinHttpReq = New WinHttpRequest

    ' Turn error trapping on
    On Error GoTo SaveErrHandler

    ' Assemble an HTTP request.
    strURL = strURL & "?slots=" & CStr(UBound(strFileName) + 1) & "&" & postVar
    WinHttpReq.Open "POST", strURL, False
    Debug.Print strURL
    
    If strUserName <> "" And strPassword <> "" Then
        ' Set the user name and password.
        WinHttpReq.SetCredentials strUserName, strPassword, _
        HTTPREQUEST_SETCREDENTIALS_FOR_SERVER
    End If
    
    '-------------------------- Becareful not to mingle too much here -----------------------------------
    
    ' Set the header
    WinHttpReq.SetRequestHeader "Content-Type", "multipart/form-data; boundary=" & BOUNDARY
       
    ' Assemble the body
    strBody = HEADER                        ' Starting tag
    
    For i = 0 To UBound(strFileName)
    
        ' Grap the name
        fname = strFileName(i)
        
        ' Grap the file
        strFile = getFile(DirPath & "\" & fname)
        
            strBody = strBody & vbCrLf & "Content-Disposition: form-data; name=""" & "upload" & _
            (i + 1) & """; filename=""" & fname & """ " & vbCrLf & "Content-type: file" & _
            vbCrLf & vbCrLf & strFile & vbCrLf
        
        If i < UBound(strFileName) Then
            strBody = strBody & "--Xu02=$" ' This is boundary tag between two files
        End If
        strFile = ""
        
    Next i
    
    strBody = strBody & FOOTER             ' Ending tag
    '----------------------------------------------------------------------------------------------------
    
    ' Because of binary zeros, post body has to convert to byte array
    aPostBody = StrConv(strBody, vbFromUnicode)
    
    ' Send the HTTP Request.
    WinHttpReq.Send aPostBody
    
    ' Display the status code and response headers.
    'UploadFiles = WinHttpReq.GetAllResponseHeaders & "  " & WinHttpReq.ResponseText
    UploadFiles = WinHttpReq.ResponseText
    
    Set WinHttpReq = Nothing
    
    Exit Function
    
SaveErrHandler:
    UploadFiles = Err.Description
    
    Set WinHttpReq = Nothing
    
End Function
Function getFile(strFileName As String) As String

    Dim strFile As String
    
    ' Grap the file
    nFile = FreeFile
    Open strFileName For Binary As #nFile
    strFile = String(LOF(nFile), " ")
    Get #nFile, , strFile
    Close #nFile
    
    getFile = strFile
    
End Function
